var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function defaultEngineRoute(host, engineName) {
    return `${host}/api/engines/${engineName}/_search`;
}
export class EngineTransporter {
    constructor(host, engineName, apiKey, getRoute = defaultEngineRoute) {
        this.host = host;
        this.engineName = engineName;
        this.apiKey = apiKey;
        this.getRoute = getRoute;
    }
    performRequest(requestBody) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!fetch)
                throw new Error("Fetch is not supported in this browser / environment");
            const response = yield fetch(this.getRoute(this.host, this.engineName), {
                method: "POST",
                body: JSON.stringify(requestBody),
                headers: {
                    "Content-Type": "application/json",
                    Authorization: `ApiKey ${this.apiKey}`
                }
            });
            const json = yield response.json();
            return json;
        });
    }
}
