import type { QueryConfig, RequestState, ResponseState, AutocompleteResponseState, APIConnector, AutocompleteQueryConfig } from "@elastic/search-ui";
declare type ConnectionOptions = {
    host: string;
    engineName: string;
    apiKey: string;
};
export * from "./types";
declare class EngineConnector implements APIConnector {
    private config;
    constructor(config: ConnectionOptions);
    onResultClick(): void;
    onAutocompleteResultClick(): void;
    onSearch(state: RequestState, queryConfig: QueryConfig): Promise<ResponseState>;
    onAutocomplete(state: RequestState, queryConfig: AutocompleteQueryConfig): Promise<AutocompleteResponseState>;
}
export default EngineConnector;
