var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import handleSearchRequest from "./handlers/search";
import handleAutocompleteRequest from "./handlers/autocomplete";
export * from "./types";
class EngineConnector {
    constructor(config) {
        this.config = config;
        if (!config.host) {
            throw new Error("Engine Host must be provided.");
        }
        if (!config.engineName) {
            throw new Error("Engine Name must be provided.");
        }
        if (!config.apiKey) {
            throw new Error("API Key must be provided.");
        }
    }
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    onResultClick() { }
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    onAutocompleteResultClick() { }
    onSearch(state, queryConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            return handleSearchRequest({
                state,
                queryConfig,
                host: this.config.host,
                engineName: this.config.engineName,
                apiKey: this.config.apiKey
            });
        });
    }
    onAutocomplete(state, queryConfig) {
        return __awaiter(this, void 0, void 0, function* () {
            return handleAutocompleteRequest({
                state,
                queryConfig,
                host: this.config.host,
                engineName: this.config.engineName,
                apiKey: this.config.apiKey
            });
        });
    }
}
export default EngineConnector;
